﻿<%@ Control Language="C#" AutoEventWireup="false" CodeBehind="AddIncident.ascx.cs" Inherits="PureChat.Plugins.OnTime.AddIncident" %>
<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="ajaxToolkit" %>
<%@ register assembly="PureChat.Plugins.OnTime" namespace="PureChat.Plugins.OnTime" tagprefix="cc1" %>
<div class="OnTimePlugin_Header"><div class="OnTimePlugin_Header_Text">Add Incident</div></div>
<div class="OnTimePlugin_AddContainer">
	<table border="0" cellspacing="2" cellpadding="0" style="width: 100%" width="100%">
		<tr>
			<td class="OnTimePlugin_LabelColumn">Incident Name:</td>
			<td>
				<asp:textbox id="txtIncidentName" runat="server" cssclass="OnTimePlugin_DataColumn_TextBox" />
			</td>
		</tr>
		<tr>
			<td class="OnTimePlugin_LabelColumn">Assign To:</td>
			<td>
				<asp:dropdownlist id="ddlUsers" runat="server" />
			</td>
		</tr>
		<tr>
			<td class="OnTimePlugin_LabelColumn" valign="top">Customer:</td>
			<td>
				<input type="hidden" id="hidCustomerContactId" value="0" runat="server" />
				<span id="customerNameLabel">[None]</span>
				<br />
				<span onclick="popupCustomerSearch();" class="OnTimePlugin_CommandLink">Search</span>
				&nbsp;
				<span onclick="clearSelectedCustomer();" class="OnTimePlugin_CommandLink">Clear</span>
				&nbsp;
				<span onclick="addCustomer();" class="OnTimePlugin_CommandLink">Add Customer</span>
				&nbsp;
				<span onclick="addCustomerContact();" class="OnTimePlugin_CommandLink">Add Contact</span>
			</td>
		</tr>
		<tr>
			<td class="OnTimePlugin_LabelColumn">Project:</td>
			<td>
				<cc1:hierarchydropdown id="ddlProjects" runat="server" />
			</td>
		</tr>
		<tr>
			<td class="OnTimePlugin_LabelColumn">Status:</td>
			<td>
				<asp:dropdownlist id="ddlStatus" runat="server" />
			</td>
		</tr>
		<tr>
			<td class="OnTimePlugin_LabelColumn" valign="top">Description:</td>
			<td valign="top">
				<asp:textbox id="txtDescription" runat="server" textmode="MultiLine" width="97%" rows="5" />
			</td>
		</tr>
	</table>
	<div class="OnTimePlugin_ButtonContainer">
		<asp:button id="btnSave" runat="server" text="Add Incident" />
		&nbsp;
		<input type="button" id="btnCancel" value="Cancel" onclick="closeWindow();" />
	</div>
</div>
<asp:panel id="addCustomerPanel" runat="server">
	<div class="OnTimePlugin_AddCustomerPanel">
		<div class="OnTimePlugin_Header"><div class="OnTimePlugin_Header_Text">Add Customer</div></div>
		<div class="OnTimePlugin_AddCustomerPanel_Container">
			<table border="0" cellpadding="0" cellspacing="0" width="100%" style="width: 100%">
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">Company Name:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomer">
						<input type='text' id='newCustomerName' class='OnTimePlugin_DataColumn_TextBox' />
					</td>
				</tr>
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">URL:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomer">
						<input type='text' id='newCustomerUrl' class='OnTimePlugin_DataColumn_TextBox' />
					</td>
				</tr>
			</table>
			<br />
			<input type='button' value='Add Customer' onclick="addCustomerSubmit();" />
			&nbsp;
			<input type='button' value='Cancel' onclick="cancelAddCustomer();" />
		</div>
	</div>
</asp:panel>
<asp:panel id="addCustomerContactPanel" runat="server">
	<div class="OnTimePlugin_AddCustomerContactPanel">
		<div class="OnTimePlugin_Header"><div class="OnTimePlugin_Header_Text">Add Customer Contact</div></div>
		<div class="OnTimePlugin_AddCustomerContactPanel_Container">
			<table border="0" cellpadding="0" cellspacing="2" width="100%" style="width: 100%">
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">Company:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomerContact">
						<span id="addCustomerContact_CustomerName">[None]</span>
						<span class="OnTimePlugin_CommandLink" onclick="addContact_SearchCustomer();">Search</span>
						&nbsp;
						<span class="OnTimePlugin_CommandLink" onclick="clearAddContact_Customer();">Clear</span>
						<input type="hidden" id="newContactCustomerId" value="0" />
						<input type="hidden" id="newContactCustomerName" value="" />
					</td>
				</tr>
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">First Name:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomerContact">
						<input type='text' id='newContactFirstName' class='OnTimePlugin_DataColumn_TextBox' />
					</td>
				</tr>
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">Last Name:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomerContact">
						<input type='text' id='newContactLastName' class='OnTimePlugin_DataColumn_TextBox' />
					</td>
				</tr>
				<tr>
					<td class="OnTimePlugin_LabelColumn_NoWidth">Email:</td>
					<td class="OnTimePlugin_DataColumn_TextBox_AddCustomerContact">
						<input type='text' id='newContactEmail' class='OnTimePlugin_DataColumn_TextBox' />
					</td>
				</tr>
			</table>
			<br />
			<input type='button' id='addCustomerContactButton' disabled="disabled" value='Add Contact' onclick="addCustomerContactSubmit();" />
			&nbsp;
			<input type='button' value='Cancel' onclick="cancelAddCustomerContact();" />
		</div>
	</div>
	<asp:panel id="searchCustomerPanel" runat="server">
		<div class="OnTimePlugin_AddContact_SearchCustomerPanel">
			<div class="OnTimePlugin_Header"><div class="OnTimePlugin_Header_Text">Search Customer</div></div>
			<div class="OnTimePlugin_AddContact_SearchCustomerPanel_Container">
				Search:&nbsp;
				<input type='text' id='searchCustomerInput' />
				<br /><br />
				<input type='button' value='Search' onclick="addContact_PerformSearchCustomer();" />
				&nbsp;
				<input type='button' value='Cancel' onclick="cancelAddContact_SearchCustomer();" />
			</div>
			<div id="customerSearchResult" class="OnTimePlugin_SearchCustomerResult" style="display: none;">
				<div class="OnTimePlugin_Header_Smaller" style="margin-bottom: 3px"><div class="OnTimePlugin_Header_Text">Customer Search Results</div></div>
				<div class="OnTimePlugin_SearchCustomerResult_Container">
					<div id="customerSearchResultContainer" style="margin: 0 auto; text-align: center"></div>
				</div>
			</div>
		</div>
	</asp:panel>
</asp:panel>
<asp:panel id="searchCustomerContactPanel" runat="server">
	<div class="OnTimePlugin_SearchCustomerPanel">
		<div class="OnTimePlugin_Header"><div class="OnTimePlugin_Header_Text">Search Customer</div></div>
		<div class="OnTimePlugin_SearchCustomerPanel_Container" style="margin-top: 3px;">
			Customer Search:
			&nbsp;
			<input type='text' id='searchCustomerContactInput' />
			<br /><br />
			<input type='button' id='searchCustomerButton' value='Search' onclick="performCustomerContactSearch();" />
			&nbsp;
			<input type='button' id='cancelSearchButton' value='Cancel' onclick="cancelCustomerContactSearch();" />
		</div>
		<div id="customerContactSearchResult" class="OnTimePlugin_SearchCustomerContactResult" style="display: none;">
			<div class="OnTimePlugin_Header_Smaller"><div class="OnTimePlugin_Header_Text">Customer Search Results</div></div>
			<div class="OnTimePlugin_SearchCustomerContactResult_Container">
				<div id="customerContactSearchResultContainer" style="margin: 0 auto; text-align: center"></div>
			</div>
		</div>
	</div>
</asp:panel>
<asp:panel id="messagePanel" runat="server">
	<div class="OnTimePlugin_MessagePanel">
		<div class="OnTimePlugin_MessagePanel_Message" id='messageSpan'></div>
		<br /><br />
		<div class="OnTimePlugin_Centering" style="margin-bottom: 8px">
			<input type='button' id='closeMessageButton' value='Ok' onclick='closeMessagePanel();' />
		</div>
	</div>
</asp:panel>
<ajaxtoolkit:modalpopupextender id="searchCustomerContactPopup" runat="server" popupControlid="searchCustomerContactPanel" targetcontrolid="searchCustomerContactPanel" backgroundcssclass="OnTimePlugin_Modal_Background" />
<ajaxtoolkit:modalpopupextender id="searchCustomerPopup" runat="server" popupControlid="searchCustomerPanel" targetcontrolid="searchCustomerPanel" backgroundcssclass="OnTimePlugin_Modal_Background" />
<ajaxtoolkit:modalpopupextender id="addCustomerPopup" runat="server" popupcontrolid="addCustomerPanel" targetcontrolid="addCustomerPanel" backgroundcssclass="OnTimePlugin_Modal_Background" />
<ajaxtoolkit:modalpopupextender id="addCustomerContactPopup" runat="server" popupcontrolid="addCustomerContactPanel" targetcontrolid="addCustomerContactPanel" backgroundcssclass="OnTimePlugin_Modal_Background" />
<ajaxtoolkit:modalpopupextender id="messagePopup" runat="server" popupcontrolid="messagePanel" targetcontrolid="messagePanel" backgroundcssclass="OnTimePlugin_Modal_Background" />
<script type="text/javascript" language="javascript">

	var searchCustomerPopupId = '';
	var searchCustomerContactPopupId = '';
	var hidCustomerId = '';
	var addCustomerPopupId = '';
	var addCustomerContactPopupId = '';
	var messagePopupId = '';
	
	var afterMessageFunc;
	
	function closeMessagePanel()
	{
		setTimeout('closeMessagePanelTimer();', 50);
	}
	
	function closeMessagePanelTimer()
	{
		var obj = $find(messagePopupId);
		obj.hide();
		if(afterMessageFunc)
			afterMessageFunc();
	}
	
	var addedCustomerSearchHandler = false;
	
	function popupCustomerSearch()
	{
		customerContactSearch_Success('&nbsp;');
		if(!addedCustomerSearchHandler)
		{
			$addHandler($get('searchCustomerContactInput'), "keypress", customerContactSearchKeyPress);
			addedCustomerSearchHandler = true;
		}
		var obj = $find(searchCustomerContactPopupId);
		obj.show();
	}
	
	function customerContactSearchKeyPress(evt)
	{
		if(evt.charCode == 13)
		{
			evt.preventDefault();
			evt.stopPropagation();
			performCustomerContactSearch();
		}
	}
	
	function cancelCustomerContactSearch()
	{
		setTimeout('closeSearchWindow();', 50);
	}
	
	function performCustomerContactSearch()
	{
		var i = $get('searchCustomerContactInput');
		if(!i)
			return;
		PureChat.Plugins.OnTime.OnTimePluginService.SearchCustomerContacts(i.value, customerContactSearch_Success, customerContactSearch_Error);
	}
	
	function customerContactSearch_Success(result)
	{
		$get('customerContactSearchResult').style.display = '';
		$get('customerContactSearchResultContainer').innerHTML = result;
	}
	
	function customerContactSearch_Error(err)
	{
	}
	
	function clearSelectedCustomer()
	{
		updateCustomerSelection(0, '[None]');
	}
	
	function updateCustomerSelection(id, name)
	{
		$get(hidCustomerId).value = id;
		$get('customerNameLabel').innerHTML = name;
	}
	
	function selectCustomerContactSearchResult(id, name)
	{
		updateCustomerSelection(id, name);
		setTimeout('closeSearchWindow();', 50);
	}
	
	function closeSearchWindow()
	{
		var obj = $find(searchCustomerContactPopupId);
		obj.hide();
	}
	
	var addedAddCustomerEnterHandler = false;
	
	function addCustomerKeyPress(evt)
	{
		if(evt.charCode == 13)
		{
			evt.preventDefault();
			evt.stopPropagation();
			addCustomerSubmit();
		}
	}
	
	function addCustomer()
	{
		if(!addedAddCustomerEnterHandler)
		{
			$addHandler($get('newCustomerName'), "keypress", addCustomerKeyPress);
			$addHandler($get('newCustomerUrl'), "keypress", addCustomerKeyPress);
			addedAddCustomerEnterHandler = true;
		}
		var obj = $find(addCustomerPopupId);
		obj.show();
		setTimeout('$get("newCustomerName").focus();', 20);
	}
	
	function cancelAddCustomer()
	{
		setTimeout('closeAddCustomerWindow();', 50);
	}
	
	function closeAddCustomerWindow()
	{
		var obj = $find(addCustomerPopupId);
		obj.hide();
	}
	
	var addedAddCustomerContactEnterHandler = false;
	
	function addCustomerContactKeyPress(evt)
	{
		if(evt.charCode == 13)
		{
			evt.preventDefault();
			evt.stopPropagation();
			addCustomerContactSubmit();
		}
	}
	
	function addCustomerContact()
	{
		if(!addedAddCustomerContactEnterHandler)
		{
			$addHandler($get('newContactFirstName'), "keypress", addCustomerContactKeyPress);
			$addHandler($get('newContactLastName'), "keypress", addCustomerContactKeyPress);
			$addHandler($get('newContactEmail'), "keypress", addCustomerContactKeyPress);
			addedAddCustomerContactEnterHandler = true;
		}
		var obj = $find(addCustomerContactPopupId);
		obj.show();
		
		setTimeout('$get("newContactFirstName").focus();', 20);
	}
	
	function cancelAddCustomerContact()
	{
		setTimeout('closeAddCustomerContactWindow();', 50);
	}
	
	function closeAddCustomerContactWindow()
	{
		var obj = $find(addCustomerContactPopupId);
		obj.hide();
	}
	
	function addCustomerContactSubmit()
	{
		PureChat.Plugins.OnTime.OnTimePluginService.AddCustomerContact($get('newContactFirstName').value, $get('newContactLastName').value, $get('newContactEmail').value, $get('newContactCustomerId').value, $get('newContactCustomerName').value, addCustomerContact_Success, addCustomerContact_Error);
	}	
	
	function addCustomerContact_Success(result)
	{
		updateCustomerSelection(result.ContactId, result.ContactDisplayName);
		closeAddCustomerContactWindow();
		showMessageWindow('Contact added successfully.');
	}
	
	var addedAddContactSearchCustomerEnterHandler = false;
	
	function addContactSearchCustomerKeyPress(evt)
	{
		if(evt.charCode == 13)
		{
			evt.preventDefault();
			evt.stopPropagation();
			addContact_PerformSearchCustomer();
		}
	}
	
	function addContact_SearchCustomer()
	{
		customerSearch_Success('&nbsp;');
		if(!addedAddContactSearchCustomerEnterHandler)
		{
			$addHandler($get('searchCustomerInput'), "keypress", addContactSearchCustomerKeyPress);
			addedAddContactSearchCustomerEnterHandler = true;
		}
		var obj = $find(searchCustomerPopupId);
		obj.show();
	}
	
	function addContact_PerformSearchCustomer()
	{
		var i = $get('searchCustomerInput');
		if(!i)
			return;
		PureChat.Plugins.OnTime.OnTimePluginService.SearchCustomers(i.value, customerSearch_Success, customerSearch_Error);
	}
	
	function customerSearch_Success(result)
	{
		$get('customerSearchResult').style.display = '';
		$get('customerSearchResultContainer').innerHTML = result;
	}
	
	function customerSearch_Error(err)
	{
	}
	
	function cancelAddContact_SearchCustomer()
	{
		setTimeout('closeAddContactSearchCustomerWindow();', 50);
	}
	
	function closeAddContactSearchCustomerWindow()
	{
		var obj = $find(searchCustomerPopupId);
		obj.hide();
	}
	
	function clearAddContact_Customer()
	{
		selectCustomerSearchResult(0, '');
	}
	
	function selectCustomerSearchResult(id, name)
	{
		$get('addCustomerContactButton').disabled = (id <= 0);
		$get('newContactCustomerId').value = id;
		
		if(id <= 0)
		{
			$get('addCustomerContact_CustomerName').innerHTML = "[None]";
			$get('newContactCustomerName').value = "";
		}
		else
		{
			$get('addCustomerContact_CustomerName').innerHTML = name;
			$get('newContactCustomerName').value = name;
		}
			
		cancelAddContact_SearchCustomer();
	}
	
	function addCustomerContact_Error(err)
	{
	}
	
	function addCustomerSubmit()
	{
		PureChat.Plugins.OnTime.OnTimePluginService.AddCustomer($get('newCustomerName').value, $get('newCustomerUrl').value, addCustomer_Success, addCustomer_Error);
	}
	
	function addCustomer_Success(result)
	{
		closeAddCustomerWindow();
		showMessageWindow('Customer added successfully.');
	}
	
	function addCustomer_Error(err)
	{
	}
	
	function showMessageWindow(msg)
	{
		$get('messageSpan').innerHTML = msg;
		var obj = $find(messagePopupId);
		obj.show();
	}
	
	var url = '';
	
	function showSuccessMessage(msg)
	{
		url = String.format(url, "'");
		msg = String.format(msg, url);
		$get('messageSpan').innerHTML = msg;
		var obj = $find(messagePopupId);
		obj.show();
	}
	
</script>